<?php

  // $connectionDB = array (
  //   'B155ACA0D3C1CE12' =>
  //   array (
  //       'state' => 'accept',
  //       'login' => 'login1',
  //       'group' => 'group1',
  //       'try' => 0,
  //       'challenge' => '9D56AC2A524ADA24',
  //       'first' => '2010/04/19 11:58:14',
  //       'last' => '2010/04/19 11:58:16',
  //       'ip' => '127.0.0.10',
  //   ),
  // );

  // XXX cleanConnection (last)

// ========================================
// information temporaire sur la connexion en lien avec les bases d'utilisateurs et de groupes
class connection {

  // ========================================
  function loadConnections () {
    global $connectionDir, $connectionPipeBase, $connectionExt, $connectionDB, $connectionLoginDBIdx;
    $connectionDB = array ();
    $connectionLoginDBIdx = array ();

    $dh = opendir ($connectionDir);
    if ($dh === false)
      return false;
    while (($file = readdir ($dh)) !== false) {
      if (is_dir ($connectionDir."/".$file) ||
	  strstr ($file, $connectionPipeBase) ||
	  strstr ($file, ".") === false)
	continue;
      $file_info = pathinfo ($file);
      if ($connectionExt != strtolower ($file_info['extension']))
	continue;
      @include $connectionDir."/".$file;
    }
    foreach ($connectionDB as $pearId => $connection) {
      $login = $connection ['login'];
      if ($login) {
	if (!isset ($connectionLoginDBIdx [$login]))
	  $connectionLoginDBIdx [$login] = array ();
	$connectionLoginDBIdx [$login] [] = $pearId;
      }
    }
  }

  // ========================================
  function saveConnection ($pearId) {
    global $connectionDB;

    $connectionDB [$pearId]["ip"]   = $_SERVER ["REMOTE_ADDR"];
    $connectionDB [$pearId]["last"] = date ("Y/m/d H:i:s");
    $file = connection::getFileName ($pearId);
    $somecontent = "<?php
\$connectionDB ['$pearId'] = ".var_export ($connectionDB [$pearId], true).";
?>\n";
    $handle = "";
    if ((file_exists ($file) && !is_writable ($file)) || !($handle = fopen ($file, 'w')) ||
	fwrite ($handle, $somecontent) === FALSE) {
      die ("Impossible de metter à jour la connexion $pearId!");
    }
  }

  // ========================================
  // retourne toutes les connexions concernant un group
  function getMembers ($groupName) {
    global $connectionDB;

    $result = array ();
    if (!$groupName)
      return $result;
    foreach ($connectionDB as $pearId => $connection) {
      if (!$connection ['login'] || "accept" != $connection['state'])
	continue;
      if ($groupName == $connection ['group'])
	$result [] = $pearId;
    }
    return $result;
  }


  // ========================================
  // retourne group d'appartenance pour un utilisateur connecté
  function getGroup ($pearId) {
    global $connectionDB;

    if (!$pearId || !$connectionDB [$pearId] || !$connectionDB [$pearId]['login'] || "accept" != $connectionDB [$pearId]['state'])
      return;
    return $connectionDB [$pearId]['group'];
  }

  // ========================================
  // fonctions d'utilisation autorisées si le login de $pearId apparait comme administrateur ou membre du groupe
  function joinGroup ($pearId, $groupName) {
    global $connectionDB, $groupDB;

    if (!$pearId || !$connectionDB [$pearId] || !$connectionDB [$pearId]['login'] || "accept" != $connectionDB [$pearId]['state'])
      return;
    if (!$groupName || !$groupDB [$groupName] ||
	!in_array ($connectionDB [$pearId]['login'], array_merge ($groupDB [$groupName] ['admin'], $groupDB [$groupName] ['member'])))
      return;
    $connectionDB [$pearId]['group'] = $groupName;
    connection::saveConnection ($pearId);
    connection::sendLoginMsg ($pearId, 'group="join" name="'.$groupName.'"');
  }

  // ========================================
  function leftGroup ($pearId) {
    global $connectionDB;

    if (!$pearId || !$connectionDB [$pearId] || !$connectionDB [$pearId]['login'] || "accept" != $connectionDB [$pearId]['state'] ||
	!$connectionDB [$pearId]['group'])
      return;
    $connectionDB [$pearId]['group'] = "";
    connection::saveConnection ($pearId);
    connection::sendLoginMsg ($pearId, 'group="left"');
  }

  // ========================================
  // déconnecte une connexion
  function connect ($pearId, $login) {
    global $connectionDB, $userDB;

    $connectionDB [$pearId]["login"] = $login;
    $connectionDB [$pearId]["state"] = "accept";
    $connectionDB [$pearId]["try"]   = 0;
    connection::sendLoginMsg ($pearId, 'user="accept" result="'.sha1 ($connectionDB [$pearId]["challenge"].$login.$userDB [$login]["passwd"]).'"');
    connection::saveConnection ($pearId);
  }

  // ========================================
  // déconnecte une connexion
  function disconnect ($pearId) {
    global $connectionDB;

    $connectionDB [$pearId]["login"]     = "";
    // XXX $connectionDB [$pearId]["group"]     = "";
    $connectionDB [$pearId]["state"]     = "unknown";
    $connectionDB [$pearId]["challenge"] = xml::newChallenge ();
    $connectionDB [$pearId]["try"]       = 0;
    connection::sendLoginMsg ($pearId, 'user="unknown" challenge="'.$connectionDB [$pearId]["challenge"].'" try="'.($connectionDB [$pearId]["try"]+1).'"');
    connection::saveConnection ($pearId);
  }

  // ========================================
  // déconnecte toutes les connexions d'un utilisateur
  function removeUser ($login) {
    global $connectionLoginDBIdx;

    if (!$login)
      return;
    if ($connectionLoginDBIdx [$login])
      foreach ($connectionLoginDBIdx [$login] as $pearId)
	connection::disconnect ($pearId);
  }

  // ========================================
  // retire la participation au groupe de tous les connexions pour un groupe
  function removeGroup ($groupName) {
    global $connectionDB;

    if (!$groupName)
      return;
    foreach ($connectionDB as $pearId => $connection) {
      if ($groupName == $connection ['group']) {
	$connectionDB [$pearId]['group'] = "";
	connection::saveConnection ($pearId);
	connection::sendLoginMsg ($pearId, 'group="left"');
      }
    }
  }

  // ========================================
  // retroune le nom correspondant à un identifiant de connexion
  function getFileName ($pearId) {
    global $connectionDir, $connectionExt;
    return "{$connectionDir}/{$pearId}.{$connectionExt}";
  }

  // ========================================
  // affiche lecontenu des files de messages
  function showConnections () {
    global $connectionDB;

    echo "<table border=\"1\">\n".
      "        <tr><th>Début</th><th>IP</th><th>Dernier</th><th>Etape</th><th>Utilisateur</th><th>Group</th></tr>";
    foreach ($connectionDB as $pearId => $connection)
      echo
      "        <tr>".
      "<td>".$connection ['first']."</td>".
      "<td>".$connection ['ip']."</td>".
      "<td>".$connection ['last']."</td>".
      "<td>".$connection ['state']."</td>".
      "<td>".$connection ['login']."</td>".
      "<td>".$connection ['group']."</td></tr>\n";
    echo "      </table>\n";
  }

  // ========================================
  // supprime toutes les files de messages (en cours d'utilisation ou pas)
  function removeConnexions () {
    global $connectionDB, $OVH;

    foreach ($connectionDB as $pearId => $connection) {
      $file = connection::getFileName ($pearId);
      $key = connection::getQueue ($pearId);
      if (!$OVH)
	msg_remove_queue ($key);
      else
	unlink ($key);
      unlink ($file);
    }
    connection::loadConnections ();
  }

  // ========================================
  // retourne la file de messages correspondant à un identifiant de connexion
  function getQueue ($pearId) {
    global $connectionDir, $connectionPipeBase, $connectionExt, $OVH;

    $fileName = connection::getFileName ($pearId);
    touch ($fileName);
    if (!$OVH)
      // $key = msgQueueId
      return msg_get_queue (ftok ($fileName, 'M'), 0666 | IPC_CREAT);
    else
      // touch ($key);
      return $connectionDir."/".$connectionPipeBase.$pearId.".".$connectionExt;
  }

  // ========================================
  // recoive des données pour un identifiant de connexion (avec blocage éventuel)
  function receiveQueue ($pearId, $wait) {
    global $OVH;

    $key = connection::getQueue ($pearId);
    if (!$OVH) {
      $stat = msg_receive ($key, 1, $type, 16384, $msg, true, ($wait ? null : MSG_IPC_NOWAIT), $err);
      return $msg;
    } else {
      $msg = null;
      while (true) {
	clearstatcache ();
	$size = filesize ($key);
	if ($size <= 0 && $wait) {
	  usleep (10);
	  continue;
	}
	$fd = fopen ($key, 'r+');
	flock ($fd, LOCK_EX);
	$msg = stream_get_contents ($fd);
	ftruncate ($fd, 0);
	flock ($fd, LOCK_UN);
	fclose ($fd);
	if ($msg)
	  return trim ($msg);
	if (!$wait)
	  return null;
      }
    }
  }

  // ========================================
  // recoive des données pour un identifiant de connexion (avec blocage éventuel)
  function sendQueue ($pearId, $msg) {
    global $OVH;

    $key = connection::getQueue ($pearId);
    if (!$OVH)
      msg_send ($key, 1, $msg, true, false, $err);
    else {
      $fd = fopen ($key, 'a+');
      flock ($fd, LOCK_EX);
      // stream_set_write_buffer ($fp, 1024);
      // stream_set_blocking ($fd, 0);
      fwrite ($fd, $msg);
      flock ($fd, LOCK_UN);
      fclose ($fd);
    }
  }

  // ========================================
  function notifyGroup ($groupName) {
    global $groupDB, $connectionLoginDBIdx;

    $group = $groupDB [$groupName];
    if (!$group)
      return;
    $partener = array_merge ($group ['admin'], $group ['member']);
    $subarg = connection::getArgInfoGroup ($groupName);
    foreach ($partener as $login)
      if ($connectionLoginDBIdx [$login])
	foreach ($connectionLoginDBIdx [$login] as $pearId)
	  connection::sendLoginMsg2 ($pearId, 'info="group"', $subarg);
  }

  // ========================================
  function getArgInfoGroup ($groupName) {
    global $groupDB;

    $group = $groupDB [$groupName];
    $subarg = '        <group name="'.$groupName.'" created="'.$group["created"].'"'.
      ' updated="'.$group["updated"].'" ip="'.$group["ip"].'" updatedBy="'.$group["updatedBy"].'"/>'."\n";
    foreach ($group["admin"] as $admin)
      $subarg .= '        <admin name="'.$admin.'"/>'."\n";
    foreach ($group["member"] as $member)
      $subarg .= '        <member name="'.$member.'"/>'."\n";
    return $subarg;
  }

  // ========================================
  function notifyGroups2Login ($login) {
    global $connectionLoginDBIdx;

    foreach (group::listGroup ($login) as $groupName)
      $subarg .= '        <group name="'.$groupName.'"/>'."\n";
    if ($connectionLoginDBIdx [$login])
      foreach ($connectionLoginDBIdx [$login] as $pearId)
	connection::sendLoginMsg2 ($pearId, 'info="groups"', $subarg);
  }

  // ========================================
  function sendLoginMsg2 ($pearId, $arg, $subarg) {
    connection::sendQueue ($pearId, "  <paquet>
    <application name=\"login\">
      <argument ".$arg.">
".$subarg."      </argument>
    </application>
  </paquet>");
  }

  // ========================================
  function sendLoginMsg ($pearId, $arg) {
    connection::sendQueue ($pearId, "  <paquet>
    <application name=\"login\">
      <argument ".$arg."/>
    </application>
  </paquet>");
  }

  // ========================================
  }

