<?php

  // $groupDB = array (
  //   'group1' => 
  //   array (
  //     'created' => '2010/04/18 12:31:35',
  //     'updated' => '2010/04/18 12:31:35',
  //     'ip' => '127.0.0.1',
  //     'updatedBy' => 'felix',
  //     'admin' => array ('loginA', 'loginB', 'loginC'),
  //     'member' => array ('login1', 'login2', 'login3'),
  //   ),
  // );
  // $groupLoginDBIdx = array (
  //   'login1' => 
  //   array ('group1', 'group2', 'group3'),
  // );

// ========================================
// les groupes enregistent les rôles.
// La participation se trouve dans la gestion des connexions.
class group {

  // ========================================
  function loadGroups () {
    global $groupDB, $groupDBName, $groupLoginDBIdx;

    $groupDB = array ();
    $groupLoginDBIdx = array ();
    if (is_file ($groupDBName))
      @include $groupDBName;
    ksort ($groupDB);
    $groupLoginDBIdx = array ();
    foreach ($groupDB as $groupName => $group) {
      foreach (array_merge ($group ['admin'], $group ['member']) as $login) {
	$groupLoginDBIdx [$login][] = $groupName;
      }
    }
    foreach (array_keys ($groupLoginDBIdx) as $login)
      $groupLoginDBIdx [$login] = array_unique ($groupLoginDBIdx [$login]);
    ksort ($groupLoginDBIdx);
  }

  // ========================================
  function saveGroups () {
    global $groupDB, $groupDBName;

    ksort ($groupDB);
    $somecontent = "<?php
// !!!!! WARNING : AUTOMATIC GENERATED FILE !!!!!

\$groupDB = ".var_export ($groupDB, true).";
?>\n";
    $handle = "";
    if ((file_exists ($groupDBName) && !is_writable ($groupDBName)) || !($handle = fopen ($groupDBName, 'w')) ||
	!flock ($handle, LOCK_EX) || fwrite ($handle, $somecontent) === FALSE || !flock ($handle, LOCK_UN)) {
      die ("Impossible de metter à jour la base !");
    }
  }

  // ========================================
  function showAllGroup () {
    global $groupDB, $connectionDB;

    echo "<table border=\"1\">\n".
      "        <tr><th>Groupe</th><th>Date de création</th><th>Mis à jour</th><th>Depuis</th><th>Par</th><th>Administrateurs</th><th>Membres</th><th>Connectés</th></tr>\n";
    foreach ($groupDB as $groupName => $group) {
      echo
	"        <tr><td>$groupName</td><td>".$group ['created']."</td>".
	"<td>".$group ['updated']."</td><td>".$group ['ip']."</td><td>".$group ['updatedBy']."</td>".
	"<td>".implode (", ", $group ['admin'])."</td>".
	"<td>".implode (", ", $group ['member'])."</td>".
	"<td>";
      $sep = "";
      foreach (connection::getMembers ($groupName) as $pearId) {
	echo $sep.($connectionDB [$pearId]['login'] ? $connectionDB [$pearId]['login'] : ("(".$connectionDB [$pearId]['state'].")"));
	$sep = ", ";
      }
      echo "</td></tr>\n";
    }
    echo "      </table>\n";
  }

  // ========================================
  // liste les noms de groupes dans lesquels $login apparait comme admin ou membre
  function listGroup ($login) {
    global $groupLoginDBIdx;

    return $groupLoginDBIdx [$login];
  }

  // ========================================
  // crée le gruope si le nom est libre et ajoute le créateur en administrateur
  function createGroup ($login, $groupName) {
    global $groupDB, $groupLoginDBIdx;

    if (!$login || !$groupName || $groupDB [$groupName])
      return;
    $groupDB [$groupName] =
      array ('created'   => date ("Y/m/d H:i:s"),
	     'updated'   => date ("Y/m/d H:i:s"),
	     'ip'        => $_SERVER ["REMOTE_ADDR"],
	     'updatedBy' => $login,
	     'admin'     => array ($login),
	     'member'    => array ());
    $groupLoginDBIdx [$login][] = $groupName;
    ksort ($groupLoginDBIdx);
    group::saveGroups ();
    connection::notifyGroups2Login ($login);
  }

  // ========================================
  // fonctions d'administration
  function removeGroup ($login, $groupName) {
    global $groupDB, $groupLoginDBIdx;

    if (!$login || !$groupName || !$groupDB [$groupName])
      return;
    if (!$groupName || !$groupDB [$groupName] || !in_array ($login, $groupDB [$groupName]["admin"]))
      return;
    $partener = array_unique (array_merge ($groupDB [$groupName] ['admin'], $groupDB [$groupName] ['member']));
    foreach ($partener as $login)
      $groupLoginDBIdx [$login] = array_diff ($groupLoginDBIdx [$login], array ($groupName));
    unset ($groupDB [$groupName]);
    group::saveGroups ();
    foreach ($partener as $login)
      connection::notifyGroups2Login ($login);
    connection::removeGroup ($groupName);
  }

  // ========================================
  function removeUser ($login) {
    global $groupDB, $groupLoginDBIdx;

    if (!$login || !$groupLoginDBIdx [$login])
      return;
    foreach ($groupLoginDBIdx [$login] as $groupName)
      if (in_array ($login, array_merge ($groupDB [$groupName] ['admin'], $groupDB [$groupName] ['member']))) {
	$groupDB [$groupName]["member"] = array_diff ($groupDB [$groupName]["member"], array ($login));
	if (in_array ($login, $groupDB [$groupName] ['admin'])) {
	  if (count ($groupDB [$groupName]["admin"]) == 1)
	    group::removeGroup ($login, $groupName);
	  else
	    $groupDB [$groupName]["admin"] = array_diff ($groupDB [$groupName]["admin"], array ($login));
	}
      }
    group::saveGroups ();
  }

  // ========================================
  function addGroupAdmin ($login, $groupName, $newAdmin) {
    global $groupDB, $groupLoginDBIdx;

    if (!$login || !$groupName || !$newAdmin || !$groupDB [$groupName])
      return;
    if (!in_array ($login, $groupDB [$groupName]["admin"]))
      return;
    $groupDB [$groupName]["updated"]   = date ("Y/m/d H:i:s");
    $groupDB [$groupName]["ip"]        = $_SERVER ["REMOTE_ADDR"];
    $groupDB [$groupName]["updatedBy"] = $login;
    $groupDB [$groupName]["admin"][]   = $newAdmin;
    sort ($groupDB [$groupName]["admin"]);
    $groupDB [$groupName]["admin"] = array_unique ($groupDB [$groupName]["admin"]);
    group::saveGroups ();
    $groupLoginDBIdx [$newAdmin][] = $groupName;
    $groupLoginDBIdx [$newAdmin] = array_unique ($groupLoginDBIdx [$newAdmin]);
    connection::notifyGroups2Login ($newAdmin);
    connection::notifyGroup ($groupName);
  }

  // ========================================
  function removeGroupAdmin ($login, $groupName, $oldAdmin) {
    global $groupDB, $groupLoginDBIdx;

    if (!$login || !$groupName || !$oldAdmin || !$groupDB [$groupName])
      return;
    if (!in_array ($login, $groupDB [$groupName]["admin"]))
      return;
    if ($oldAdmin == $login && count($groupDB [$groupName]["admin"]) == 1) {
      group::removeGroup ($login, $groupName);
      return;
    }
    $groupDB [$groupName]["updated"]   = date ("Y/m/d H:i:s");
    $groupDB [$groupName]["ip"]        = $_SERVER ["REMOTE_ADDR"];
    $groupDB [$groupName]["updatedBy"] = $login;
    $groupDB [$groupName]["admin"]     = array_diff ($groupDB [$groupName]["admin"], array ($oldAdmin));
    group::saveGroups ();
    $groupLoginDBIdx [$oldAdmin] = array_diff ($groupLoginDBIdx [$oldAdmin], array ($groupName));
    connection::notifyGroups2Login ($oldAdmin);
    connection::notifyGroup ($groupName);
  }

  // ========================================
  function addGroupMember ($login, $groupName, $newMember) {
    global $groupDB, $groupLoginDBIdx;

    if (!$login || !$groupName || !$groupDB [$groupName])
      return;
    if (!in_array ($login, $groupDB [$groupName]["admin"]))
      return;
    $groupDB [$groupName]["updated"]   = date ("Y/m/d H:i:s");
    $groupDB [$groupName]["ip"]        = $_SERVER ["REMOTE_ADDR"];
    $groupDB [$groupName]["updatedBy"] = $login;
    $groupDB [$groupName]["member"][]  = $newMember;
    sort ($groupDB [$groupName]["member"]);
    $groupDB [$groupName]["member"] = array_unique ($groupDB [$groupName]["member"]);
    group::saveGroups ();
    $groupLoginDBIdx [$newMember][] = $groupName;
    $groupLoginDBIdx [$newMember] = array_unique ($groupLoginDBIdx [$newMember]);
    connection::notifyGroups2Login ($newMember);
    connection::notifyGroup ($groupName);
  }

  // ========================================
  function removeGroupMember ($login, $groupName, $oldMember) {
    global $groupDB, $groupLoginDBIdx;

    if (!$login || !$groupName || !$groupDB [$groupName])
      return;
    if (!in_array ($login, $groupDB [$groupName]["admin"]))
      return;
    $groupDB [$groupName]["updated"]   = date ("Y/m/d H:i:s");
    $groupDB [$groupName]["ip"]        = $_SERVER ["REMOTE_ADDR"];
    $groupDB [$groupName]["updatedBy"] = $login;
    $groupDB [$groupName]["member"]    = array_diff ($groupDB [$groupName]["member"], array ($oldMember));
    group::saveGroups ();
    $groupLoginDBIdx [$oldMember] = array_diff ($groupLoginDBIdx [$oldMember], array ($groupName));
    connection::notifyGroups2Login ($oldMember);
    connection::notifyGroup ($groupName);
  }

  // ========================================
}
