<?php

  /*

   * <bundle>
   *   <paquet>
   *     <application name="login">
   *       <argument user="unknown" />
   *       <argument user="unknown" challenge="AA6C1B8851EBBAC2" try="x" />
   *       <argument user="reject" />
   *       <argument user="accept" result="AA6C1B8851EBBAC2" />
   *       <argument group="join" name="group1" />
   *       <argument group="left" />
   *       <argument info="passwdUnchanged" />
   *       <argument info="passwdUpdated" />

   // XXX
   *       <argument info="user" name="login1" mel="" created="" updated=""  ip="" />

   *       <argument info="group">
   *         <group name="group1" created="YYYY/MM/DD HH:MM:SS" updated="YYYY/MM/DD HH:MM:SS" ip="d.d.d.d" updatedBy="login1" />
   *         <admin name="admin1"/>
   *         <admin name="admin2"/>
   *         <member name="member1"/>
   *         <member name="member2"/>

   // XXX est-ce là qu'il faut traiter des connectés
   *         <connected name="member1"/>
   *         <connected name="member2"/>
   *         <connected name="member3"/>
   *       </argument>

   // XXX liste uniquement les groupes auquels on peut se connecter
   // algo
   // G = liste des groupes où $login apparait comme admin ou membre
   // liste toutes les connexions ou le groupe appartient à G (mémorise le groupe dans un tableau de login)
   // unicité des groupes dans le tableau de login

   *       <argument info="connection">
   *         <user name="login1">
   *           <groupe name="group1"/>
   *           <groupe name="group2"/>
   *         <user/>
   *       </argument>

   *       <argument info="groups">
   *         <group name="group1"/>
   *         <group name="group2"/>
   *         <group name="group3"/>
   *       </argument>
   *     </application>
   *   </paquet>
   * </bundle>
   *   //
   * <?xml version="1.0" encoding="UTF-8"?>
   * <bundle>
   *   <paquet pearId="AA6C1B8851EBBAC2">
   *     <application name="login">
   *       <argument ask="connect" login="login1" />
   *       <argument ask="connect" login="login1" result="AA6C1B8851EBBAC2" />
   *       <argument ask="disconnect" />
   *       <argument ask="changepass" old="sha1" new="sha2" />
   *       <argument ask="setGroup" group="group1" />
   *       <argument ask="createGroup" group="group1" />
   *       <argument ask="removeGroup" group="group1" />
   *       <argument ask="addGroupAdmin" group="group1" login="admin1" />
   *       <argument ask="removeGroupAdmin" group="group1" login="admin1" />
   *       <argument ask="addGroupMember" group="group1" login="member1" />
   *       <argument ask="removeGroupMember" group="group1" login="member1" />

   // XXX
   *       <argument ask="user" login="login1"/>
   *       <argument ask="group" group="group1"/>
   *       <argument ask="groups" />
   *     </application>
   *   </paquet>
   * </bundle>
   */

  // ========================================
class xml {

  // ========================================
  // Retroune un valeur aléatoire de 16 caractères hexadécimaux
  function newChallenge () {
    $num = array ("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F");
    $result = "";
    for ($i = 0; $i < 16; $i++)
      $result .= $num [rand (0, 16)];
    return $result;
  }

  // ========================================
  // lit le document XML en entrée standard
  function readXML () {
    $xml = trim (file_get_contents ("php://input"));
    $request = new DOMDocument ("1.0", "utf8");
    $request->loadXML ($xml);
    $bundle = $request->documentElement;
    $wait = $bundle->getAttribute ("waitAnswer") == "yes";
    $paquets = $bundle->getElementsByTagName ("paquet");
    $firstPaquet = $paquets->item (0);
    $pearId = $firstPaquet->getAttribute ("pearId");

    return array ($request, $bundle, $wait, $paquets, $firstPaquet, $pearId);
  }

  // ========================================
  // ecrit le document XML en sortie standard
  function writeXML ($msg) {
    header("Content-Type: application/xml");

    $reponse = new DOMDocument ("1.0", "utf8");
    $bundle = $reponse->createElement ("bundle");
    $reponse->appendChild ($bundle);
    if ($msg) {
      $doc = DOMDocument::loadXML ($msg);
      $bundle->appendChild ($reponse->importNode ($doc->documentElement, true));
    }
    $reponse->formatOutput = true;

    $body = $reponse->saveXML ();
    header("Content-Length: ".strlen ($body));
    echo $body;
    //$reponse->save("php://output") . "\n";
  }

  // ========================================
  // analyse la partie gestion de la connexion dans le protocole
  // supprime l'application "login" du paquet
  function login ($pearId, $paquet) {
    global $userDB, $groupDB, $connectionDB;

    // Gestion des application login
    $applications = $paquet->getElementsByTagName ("application");
    $arg = array ("ask" => "", "login" => "", "group" => "", "result" => "", "old" => "", "new" => "");
    for ($i = $applications->length - 1 ; $i >=0; $i--) {
      $application = $applications->item ($i);
      if ($application->getAttribute ("name") == "login") {
	$arguments = $application->getElementsByTagName ("argument");
	for ($j = $arguments->length -1 ; $j >= 0; $j--) {
	  $argument = $arguments->item ($j);
	  foreach (array_keys ($arg) as $p) {
	    $v = $argument->getAttribute ($p);
	    if ($v)
	      $arg [$p] = $v;
	  }
	}
	$paquet->removeChild ($application);
      }
    }

    // gestion des états
    if ($connectionDB [$pearId]["state"] == "accept") {
      if ($arg ["ask"] == "disconnect") {
	connection::disconnect ($pearId);
      } elseif ($arg ["ask"] == "setGroup") {
	if ($arg ["group"])
	  connection::joinGroup ($pearId, $arg ["group"]);
	else
	  connection::leftGroup ($pearId);
      } elseif ($arg ["ask"] == "createGroup") {
	group::createGroup ($connectionDB [$pearId]["login"], $arg ["group"]);
      } elseif ($arg ["ask"] == "removeGroup") {
	group::removeGroup ($connectionDB [$pearId]["login"], $arg ["group"]);
      } elseif ($arg ["ask"] == "addGroupAdmin") {
	group::addGroupAdmin ($connectionDB [$pearId]["login"], $arg ["group"], $arg ["login"]);
      } elseif ($arg ["ask"] == "removeGroupAdmin") {
	group::removeGroupAdmin ($connectionDB [$pearId]["login"], $arg ["group"], $arg ["login"]);
      } elseif ($arg ["ask"] == "addGroupMember") {
	group::addGroupMember ($connectionDB [$pearId]["login"], $arg ["group"], $arg ["login"]);
      } elseif ($arg ["ask"] == "removeGroupMember") {
	group::removeGroupMember ($connectionDB [$pearId]["login"], $arg ["group"], $arg ["login"]);
      } elseif ($arg ["ask"] == "groups") {
	$subarg = "";
	foreach (group::listGroup ($connectionDB [$pearId]["login"]) as $groupName)
	  $subarg .= '        <group name="'.$groupName.'"/>'."\n";
	connection::sendLoginMsg2 ($pearId, 'info="groups"', $subarg);
      } elseif ($arg ["ask"] == "group") {
	if ($groupDB [$arg ["group"]])
	  connection::sendLoginMsg2 ($pearId, 'info="group"', connection::getArgInfoGroup ($arg ["group"]));
      } elseif ($arg ["ask"] == "changepass") {
	if ($arg ["old"] && $arg ["new"] && $arg ["old"] == $userDB [$connectionDB [$pearId]["login"]]) {
	  $userDB [$connectionDB [$pearId]["login"]]["passwd"] = $arg ["new"];
	  user::saveUsers ();
	  connection::sendLoginMsg ($pearId, 'info="passwdUpdated"');
	  connection::saveConnection ($pearId);
	} else {
	  connection::sendLoginMsg ($pearId, 'info="passwdUnchanged"');
	  connection::saveConnection ($pearId);
	}
      }
    } elseif ($connectionDB [$pearId]["state"] == "reject") {
      die ("rejected");
    } elseif ($connectionDB [$pearId]["state"] == "unknown") {
      if ($arg ["ask"] == "connect") {
	$pass = $userDB [$arg ["login"]]["passwd"];
	if (!$pass || $arg ["result"] != sha1 ($connectionDB [$pearId]["challenge"].$pass)) {
	  $connectionDB [$pearId]["try"]++;
	  if ($connectionDB [$pearId]["try"] >= 3) {
	    $connectionDB [$pearId]["state"] = "reject";
	    connection::sendLoginMsg ($pearId, 'user="reject"');
	    connection::saveConnection ($pearId);
	  } else {
	    $connectionDB [$pearId]["state"]     = "unknown";
	    $connectionDB [$pearId]["challenge"] = xml::newChallenge ();
	    connection::sendLoginMsg ($pearId, 'user="unknown" challenge="'.$connectionDB [$pearId]["challenge"].'" try="'.$connectionDB [$pearId]["try"].'"');
	    connection::saveConnection ($pearId);
	  }
	} else {
	  connection::connect ($pearId, $arg ["login"]);
	}
      }
    } else {
      $connectionDB [$pearId]["first"]     = date ("Y/m/d H:i:s");
      connection::disconnect ($pearId);
    }
  }

  // ========================================
  // diffuse un noeud XML aux autre connexion
  // XXX filter suivant connexion
  function broadcast ($pearId, $request, $node) {
    global $connectionDB;

    if (!$node)
      return;


    foreach (connection::getMembers (connection::getGroup ($pearId)) as $pearId2)  {
      //    foreach ($connectionDB as $pearId2 => $connection) {
      if ($pearId2 == $pearId)
	continue;
      connection::sendQueue ($pearId2, $request->saveXML ($node));
    }
  }

  // ========================================
  }
