<?php
  /**
   * @license    http://www.cecill.info/licences/Licence_CeCILL-B_V1-fr.html
   * @author     Francois Merciol <webmestre@parlenet.org>
   *
   * Plugin Chess: manage events per wiki @groups
   */
 
if (!defined ('DOKU_INC'))
    define ('DOKU_INC', realpath (dirname (__FILE__).'/../../').'/');
if (!defined ('DOKU_PLUGIN'))
    define ('DOKU_PLUGIN', DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');

require_once ('chess.class.php');

// ============================================================
class syntax_plugin_chess extends DokuWiki_Syntax_Plugin {
 
  // ============================================================
  function getType (){ return 'substition'; }
  function getPType (){ return 'block';}

  // XXX Just before build in links XXX
  function getSort (){ return 299; }
 
  function connectTo ($mode) {
    $this->Lexer->addSpecialPattern ('~~CHESS[^~]*~~', $mode, 'plugin_chess');
  }
 
 
  // ============================================================
  function handle ($match, $state, $pos, Doku_Handler $handler){
    switch ($state) {
    case DOKU_LEXER_SPECIAL :
      return array ($state, trim (substr ($match, 7, -2)));
    default:
      return array ($state);
    }
  }

  // ============================================================
  function render ($mode, Doku_Renderer $renderer, $indata) {
    if ($mode == 'xhtml'){
      list ($state, $args) = $indata;

      switch ($state) {
      case DOKU_LEXER_SPECIAL :
	$chess = new chess ();
	$renderer->info['cache'] = FALSE;

	// help
	if (preg_match_all ("#(\"[^\"]*\")* help (\"[^\"]*\")*#", strtolower ($args), $dumy) > 0) {
	  $url = "http://parlenet.org/admin/plugins/chess/";
	  $renderer->doc .=
	    '      <h1>Chess Help V0.9</h1>'.NL.
	    '      <p><a class="urlextern" rel="nofollow" title="'.$url.'" href="'.$url.'">'.$url.'</a><p>'.NL;
	  return true;
	}

	ob_start();

 	if (preg_match_all ("#completeForm#", $args, $dumy) > 0) 
	  $chess->completeForm ();

 	if (preg_match_all ("#printUserForm#", $args, $dumy) > 0) 
	  $chess->printUserForm ();
 	if (preg_match_all ("#printGroupForm#", $args, $dumy) > 0) 
	  $chess->printGroupForm ();
 	if (preg_match_all ("#printConnectionForm#", $args, $dumy) > 0) 
	  $chess->printConnectionForm ();

 	if (preg_match_all ("#printUserTab#", $args, $dumy) > 0) {
	  $chess->printUserTab ();
	}
 	if (preg_match_all ("#printGroupTab#", $args, $dumy) > 0) 
	  $chess->printGroupTab ();
 	if (preg_match_all ("#printConnectionTab#", $args, $dumy) > 0) 
	  $chess->printConnectionTab ();

	$renderer->doc .= ob_get_contents();
	ob_end_clean();
	return $text;
      }
      return true;
    }
    return false;
  }

  // ============================================================
} // syntax_plugin_CHESS
?>
